Subject: PROPOSAL - i109: Clarify entity / representation / variant terminology

From: Mark Nottingham <[email-masked]>
Date: Mon, 28 Jul 2008 14:49:02 +0100

I saw a number of +1's to this rough plan, and only Brian offering  
another path, which didn't seem to get much support.

Let's try doing this (i.e., getting rid of variant -- remembering that  
there's a separate issue for 'requested variant' -- and change the  
definition of representation to be the same as that of entity, giving  
editors discretion to adjust instances of each as appropriate). We can  
revisit if necessary.

On 09/05/2008, at 7:09 AM, Mark Nottingham wrote:

> <http://www3.tools.ietf.org/wg/httpbis/trac/ticket/109>
>
> The following three terms are defined in 2616:
>> entity
>>
>> The information transferred as the payload of a request or  
>> response. An entity consists of metainformation in the form of  
>> entity-header fields and content in the form of an entity-body, as  
>> described in section 7.
>>
>> representation
>>
>> An entity included with a response that is subject to content  
>> negotiation, as described in section 12. There may exist multiple  
>> representations associated with a particular response status.
>>
>> variant
>>
>> A resource may have one, or more than one, representation(s)  
>> associated with it at any given instant. Each of these  
>> representations is termed a 'varriant'. Use of the term 'variant'  
>> does not necessarily imply that the resource is subject to content  
>> negotiation.
>>
>
>
> It's been asserted that there's no real distinction between these  
> terms (keeping in mind that the distinction between "a particular  
> instance of an entity/representation/variant" and "the entity/ 
> representation/variant that might be seen under particular  
> circumstances" is a separate issue, #69).
>
> If we can agree on that, we only need to find a way to rationalise  
> the terms in the spec.
>
> Straw-man proposal:
>
> 1) "variant" occurs 16 times in the -02 specs, and a good portion of  
> those is the "requested variant" text. If we ignore those instances  
> for the moment, the expedient thing to do would seem to be to change  
> the remaining occurrences to either "entity" or "representation,"  
> and remove this term altogether.
>
> 2) "representation" occurs 47 times in the -02 specs, while "entity"  
> occurs 420 times.
>
> One option would be to switch all occurrences of "entity" over to  
> "representation" or vice-versa. If we do the former, we'll end up  
> with awkward things like changing the classification of "entity- 
> header fields" to "representation-header fields" and "entity tags"  
> to "representation tags." Doing the latter seems more  
> straightforward, but it still jars some.
>
> A more moderate approach to #2 would be to choose a preferred term,  
> migrate to it where it's sensible (at editors' discretion), and  
> explicitly define the terms to mean the same thing.
>
> Thoughts?
>
>
> --
> Mark Nottingham     http://www.mnot.net/
>

--
Mark Nottingham     http://www.mnot.net/